﻿Public Class Class1
    Public Shared Function GetHeatMapColor(ByVal GoalDiffValue As Decimal, ByVal MinGoalDiffValue As Decimal, ByVal MaxGoalDiffValue As Decimal) As String

        Dim ColVar1 As Integer
        Dim ColVar2 As Integer
        Dim ColVar3 As Integer

        Dim iColor1 As Integer
        Dim iColor2 As Integer
        Dim iColor3 As Integer

        If (GoalDiffValue < 0) Then

            ColVar1 = Convert.ToInt32(Left(Right("#FF0000", 6), 2), 16)
            ColVar2 = Convert.ToInt32(Left(Right("#FF0000", 4), 2), 16)
            ColVar3 = Convert.ToInt32(Right("#FF0000", 2), 16)

            iColor1 = ColVar1 + CInt(Math.Round(((MinGoalDiffValue * -1) - (GoalDiffValue * -1)) * ((255 - ColVar1) / (MinGoalDiffValue * -1))))
            iColor2 = ColVar2 + CInt(Math.Round(((MinGoalDiffValue * -1) - (GoalDiffValue * -1)) * ((255 - ColVar2) / (MinGoalDiffValue * -1))))
            iColor3 = ColVar3 + CInt(Math.Round(((MinGoalDiffValue * -1) - (GoalDiffValue * -1)) * ((255 - ColVar3) / (MinGoalDiffValue * -1))))

            Return ("#" & iColor1.ToString("X2") & iColor2.ToString("X2") & iColor3.ToString("X2"))

        ElseIf (GoalDiffValue > 0) Then

            ColVar1 = Convert.ToInt32(Left(Right("#00B050", 6), 2), 16)
            ColVar2 = Convert.ToInt32(Left(Right("#00B050", 4), 2), 16)
            ColVar3 = Convert.ToInt32(Right("#00B050", 2), 16)

            iColor1 = ColVar1 + CInt(Math.Round((MaxGoalDiffValue - GoalDiffValue) * ((255 - ColVar1) / MaxGoalDiffValue)))
            iColor2 = ColVar2 + CInt(Math.Round((MaxGoalDiffValue - GoalDiffValue) * ((255 - ColVar2) / MaxGoalDiffValue)))
            iColor3 = ColVar3 + CInt(Math.Round((MaxGoalDiffValue - GoalDiffValue) * ((255 - ColVar3) / MaxGoalDiffValue)))

            Return ("#" & iColor1.ToString("X2") & iColor2.ToString("X2") & iColor3.ToString("X2"))

        Else
            Return "#FFFFFF"
        End If

    End Function
End Class
